unit uListe;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,Graphics,Contnrs,uPaint2Obj,upaint2ObjBase,
  StdCtrls,LCLIntf,RTTIGrids,dialogs,uextras,uPaint2Object;
  
const
  nul1 = 0;
  Backgrund      = -2;
  None           = -1;
  alt_Line       = 0;
  alt_Dreieck    = 1;
  alt_Vireck     = 2;
  alt_kreis      = 3;
  alt_Text       = 4;
  alt_Poligon    = 5;
  alt_agr        = 6; // abgerundes Reckeck

  Neu_Line       = 30;
  Neu_Dreieck    = 31;
  Neu_Vieck      = 32;
  Neu_Kreis      = 33;
  Neu_Text       = 34;
  Neu_Poligon    = 35;
  Neu_agr        = 36; // abgerundes Recheck

  Allgemein_cf   = 60; // Farbfller;
  Allgemein_cp   = 61; // Farbfinder

type

  { TmyList }

  TPaint2Main = class
  end;

  TmyList = class
  private
    fBuffer:TBitmap;
    fselectObject:TPaint2BasesObj;
    fVt:TTIPropertyGrid;
    function GetSelect: TPaint2BasesObj;
    procedure SetSelect(const AValue: TPaint2BasesObj);
    procedure SetSelectObject(const AValue: TPaint2BasesObj);
  public
    liste:TObjectList;
    usrListBox:TListBox;
    
    itemindex:integer;
    Paint2Main:tpaint2main;
    bg:Tbg;
    property selobject:TPaint2BasesObj read GetSelect write SetSelectObject;

    function GetItemIndex(x,y:Integer;Obj:TObjectList;state:TShiftState):Integer;

    function GetPaint2Obj(index:Integer):TPaint2BasesObj;
    function DeleteObject(index:integer):Integer;
    function GetSelObject:Integer;
    function AddObj(toolindex:Integer):TPaint2Object;

    procedure SetVisibleObj(index:Integer; value:Boolean);
    procedure SetBrush(Index:Integer; value:TBrush);
    procedure SetPen(Index:Integer; value:TPen);
    constructor Create(oi:TTIPropertyGrid;buffer:tBitmap;pBg:Tbg);
    function GetName(objtyp:Integer):Integer;
    procedure Clear;
    procedure SetSelObj(value:Boolean);
    procedure UpdatetOI;
  published
  end;


implementation

{ TmyList }


function TmyList.GetItemIndex(x,y:Integer;Obj:TObjectList;state:TShiftState):Integer;
var
  i,pIndex:Integer;
  r:TRect;
  Region:     THandle;
begin
  pIndex:=-1;

  for i:=0 to obj.count-1 do begin
    with TPaint2BasesObj(liste.items[i]) do begin
     if obj.Items[i] is TLine = false then begin
        r.left:=position.x; r.top:=position.y; r.Right:=size.x;r.Bottom:=size.y;
        if PtInRect(r,point(x,y)) = true then
          pindex:=i;
     end
     else begin
     end;
    end;
  end;
  if pindex > -1 then begin
    selobject:=TPaint2BasesObj(liste.items[pindex]);
    itemindex:=pIndex;
  end;
  writeLn(IntTostr(Pindex));

  result:=Pindex;
  if pindex > -1 then begin
    if ssshift in state then
    TPaint2BasesObj(liste.items[pindex]).Sel:=True;
  end
  else begin
    SetSelObj(false);
    selobject:=bg;
  end;
  Region:=0;
//  Region
end;

function TmyList.GetName(objtyp:Integer):Integer;
var
  i,z:Integer;
begin
  z:=-1;
  if objtyp < 80 then begin
    for i:=0 to liste.count -1 do begin
      if TPaint2BasesObj(liste.items[i]).Typ = objtyp then
        inc(z)
    end;
  end
  else begin
    for i:=0 to usrListBox.items.count -1 do begin
      if usrListBox.Items.Objects[i] is tImageListB then
        inc(z)
    end;

  end;
  
  result:=z+1;
end; // GetName

function TmyList.GetSelect: TPaint2BasesObj;
begin
  result:=fselectObject;
end;

procedure TmyList.SetSelect(const AValue: TPaint2BasesObj);
begin
  fselectObject:=AValue;
end;

function TmyList.GetPaint2Obj(index: Integer): TPaint2BasesObj;
begin
  if index > -1 then
    result:=TPaint2BasesObj(liste.items[index])
  else
    result:=nil;
end;

procedure TmyList.SetSelectObject(const AValue: TPaint2BasesObj);
begin
  fselectObject:=AValue;
  if AValue <> NIL then begin
    fVt.TIObject:=Avalue;
      writeLn('608246608246');
  end
  else begin
    if Bg <> NIL then begin
      writeLn('Hallo, du test');
      fVt.TIObject:=Bg;
    end;
  end;
end;

function TmyList.DeleteObject(index: integer): Integer;
var
  i:Integer;
begin
  if index = -2 then begin
    for i:=liste.Count-1 downto 0 do begin
      if TPaint2BasesObj(liste.Items[i]).Sel = true then
        liste.Delete(i);
    end;
  end;
end; // DeleteObject

function TmyList.GetSelObject: Integer;
begin
  result:=1;
end; // GetSelObject

function TmyList.AddObj(toolindex:Integer): TPaint2Object;
var
  paint2obj:TPaint2Object;
begin
  fBuffer.Canvas.Brush.color:=clBlue;
  paint2obj:=nil;
  if toolindex = alt_Vireck then paint2obj:=TRectEck.Create(fBuffer);
  if toolindex = alt_kreis then paint2obj:=TKreis.Create(fBuffer);
  if toolindex = alt_Line then  paint2obj:=TLine.Create(fBuffer);

   if toolindex = alt_agr then  paint2obj:=troundrec.Create(fBuffer);

  if toolindex = Extras_ImageListB then begin
    paint2obj:=tImageListB.Create;
  end;
  

  if toolindex < 80 then begin
    if paint2obj <> NIL then begin
      liste.Add(paint2obj);
      result:=TPaint2Object(liste[liste.Count-1]);
      selobject:=TPaint2BasesObj(liste[liste.Count-1]);
     itemindex:=liste.Count-1;
   end
    else
      result:=nil;
  end
  else begin

    usrListBox.Items.AddObject(paint2obj.Name,tImageListB(paint2obj));
    result:=TPaint2Object(usrListBox.Items.Objects[usrListBox.items.Count-1]);

  end;
end; // AddObj

procedure TmyList.SetVisibleObj(index: Integer; value: Boolean);
begin

end; // SetVisibleObj

procedure TmyList.SetBrush(Index: Integer; value: TBrush);
begin

end; // SetBrush

procedure TmyList.SetPen(Index: Integer; value: TPen);
begin

end; // SetPen

constructor TmyList.Create(oi:TTIPropertyGrid;buffer:TBitmap;pBg:Tbg);
begin
  liste:=TObjectlist.Create;
  fbuffer:=TBitmap.Create;
  fbuffer.Assign(buffer);
  itemindex:=-1;
  bg:=pbg; fVt:=oi;
  selobject:=nil;
end;

procedure Tmylist.Clear;
begin

end;

procedure Tmylist.SetSelObj(value:Boolean);
var
  i:Integer;
begin
  for i:=0 to liste.Count-1 do begin
    TPaint2BasesObj(liste.Items[i]).Sel:=value;
  end;
//  itemindex:=-1;
end;

procedure Tmylist.UpdatetOI;
begin
  if (selobject <> NIL) and (fvt.TIObject <> NIL) then begin
    fvt.TIObject:=selobject;
    fvt.PropEditLookupRootChange;
    fvt.RefreshPropertyValues;
    fvt.Clear;

    writeln('test');
    fvt.Update;
    fvt.Invalidate;
    fvt.Refresh;

  end;

end;

end.

