unit uextras;

{$mode objfpc}{$H+}

interface

uses
  LCLIntf,  SysUtils, Classes, Graphics, Controls, Forms,contnrs,
  Dialogs, ExtCtrls,StdCtrls,upaint2ObjBase,uPaint2Object,FPCanvas,GraphicPropEdit;

type

  { tImageListB }


  TmyImage = class(TPanel)
  private
    FPicture: TPicture;
    fImage:TImage;
        function GetPicture: TPicture;
    procedure SetPicture(Value: TPicture);
 public
    constructor Create;
  published
    property Picture: TPicture read GetPicture write SetPicture;
  end;
  
//  ttest = class(Tpanel)
//  end;
  
  tImageListB = class(TPaint2Object)
  public
    items:TObjectList;
    constructor Create;
  private
    fpx,fpy,fsx,fsy:Integer;
    fmyimage:TmyImage;
    fImage:TImage;
    fobject:TObjectList;
    function GetPicture:TPicture;
    procedure SetPicture(Value: TPicture);

    procedure SetIndex(index,value:Integer);
    function GetIndex(index:Integer):integer;
//    constructor Create;

  published

    property PX:Integer index 1 read getIndex write SetIndex;
    property PY:Integer index 2 read getIndex write SetIndex;
    property SX:Integer index 3 read getIndex write SetIndex;
    property SY:Integer index 4 read getIndex write SetIndex;
    property Image: TPicture read GetPicture write SetPicture;
  end;

implementation

constructor tImageListB.Create;
begin
//  inherited Create;
  items:=TObjectList.Create;
  Name:='ImagelistB';
  fImage:=TImage.Create(Screen.ActiveForm);
  fImage.Canvas.Brush:=Tbrush.Create;
  fImage.Canvas.Pen:=TPen.Create;
  fImage.Canvas.font:=tFont.Create;
  fImage.canvas.brush.Bitmap:=TBitmap.Create;

  fImage.Picture:=TPicture.create;
  fImage.Picture.Bitmap:=TbitMap.Create;
  fimage.Parent:=Screen.ActiveForm;
  fimage.Visible:=true;
  fmyimage:=TmyImage.Create;

end;

procedure tImagelistb.SetIndex(index,value:Integer);
begin
  if index = 1 then fpx:=Value;
  if index = 2 then fpy:=Value;
  if index = 3 then fsx:=Value;
  if index = 4 then fsy:=Value;
end;

function tImagelistb.GetIndex(index:Integer):integer;
begin
  if index = 1 then result:=fpx;
  if index = 2 then result:=fpy;
  if index = 3 then result:=fsx;
  if index = 4 then result:=fsy;
end;

function tImagelistb.GetPicture: TPicture;
begin
  result:=fmyimage.fImage.Picture;
//   Result:= fImage.Picture;
end;

procedure tImagelistb.SetPicture(Value: TPicture);
begin
   if (Value <> fmyimage.Picture) then
    fmyimage.fImage.Picture:= Value;
end;

function TmyImage.GetPicture: TPicture;
begin
   Result:= fImage.Picture;
end;

procedure TmyImage.SetPicture(Value: TPicture);
begin

//   if (Value <> FImage.Picture) then
    FImage.Picture:= Value;
end;

constructor TmyImage.Create;
begin
  fImage:=TImage.Create(Screen.ActiveForm);
  fImage.Picture:=TPicture.Create;
  fImage.Picture.Bitmap:=TbitMap.Create;

  FPicture:=TPicture.Create;
end;

end.

